SystemOrganization addCategory: #'SqSync-Shared'!
SystemOrganization addCategory: #'SqSync-Client'!
SystemOrganization addCategory: #'SqSync-Server'!
SystemOrganization addCategory: #'SqSync-Tests'!

SocketStream subclass: #SyTcpSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyTcpSocket class methodsFor: 'instance creation' stamp: 'mt 5/10/2010 11:05:32.461'!
connectToHost: nameOrAddressString port: anInteger
	
	^ self
		openConnectionToHostNamed: nameOrAddressString
		port: anInteger! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:48.023'!
remoteAddress

	^ self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:53.871'!
remotePort

	^ self socket remotePort! !

!SyTcpSocket methodsFor: 'waiting' stamp: 'mt 5/9/2010 17:23:15.848'!
waitForDataIfClosed: aBlock

	^ self socket waitForDataIfClosed: aBlock! !

MwMethodWrapper subclass: #SyMethodWrapper
	instanceVariableNames: 'instrumentor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyMethodWrapper class methodsFor: 'as yet unclassified' stamp: 'SR 5/16/2010 17:18:44.185'!
on: aSymbol inClass: aClass for: anInstrumentor

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper instrumentor: anInstrumentor.
	^ wrapper! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:42.497'!
instrumentor

	^ instrumentor! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:39.016'!
instrumentor: anObject

	instrumentor := anObject! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'SR 5/16/2010 17:22:34.282'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| result |
	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	instrumentor ifNotNil: [
		instrumentor methodCalled: (self selector) on: anObject with: anArrayOfObjects resulting: result.
	].
	^ result! !

Object subclass: #Person
	instanceVariableNames: 'givenName surname birthday address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!Person commentStamp: 'mt 5/19/2010 13:05:53.083' prior: 0!
I am part of the example domain model.!

!Person class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 12:28:45.274'!
givenName: aFirstString surname: aSecondString

	^ (self new)
		givenName: aFirstString;
		surname: aSecondString;
		yourself.! !

!Person methodsFor: 'comparing' stamp: 'SR 5/15/2010 15:24:16.133'!
= anObject 

	^ (self givenName = anObject givenName) and: [self surname = anObject surname] and: [self birthday = anObject birthday] and: [self address = anObject address]! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:08.009'!
address
	^ address! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:51.253'!
address: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	address := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:18.253'!
birthday
	^ birthday! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:27:34.621'!
birthday: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	birthday := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:24.381'!
givenName
	^ givenName! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:32.385'!
givenName: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	givenName := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:32.002'!
surname
	^ surname! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:22.555'!
surname: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	surname := aString.! !

Object subclass: #SyClassInstrumentor
	instanceVariableNames: 'classes methods processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:27:33.49'!
instrumentClass: aClass

	| metaClass |
	metaClass := aClass class.
	(self isClassInstrumented: aClass) ifFalse: [
		{aClass. metaClass} do: [:c |
			self instrumentedClasses add: c.
			c selectors do: [:selector | self instrumentMethod: selector inClass: c ]
		]
	].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 17:19:22.051'!
instrumentMethod: selector inClass: aClass

	| wrapper |
	(self isMethodInstrumented: selector inClass: aClass)  ifFalse: [
		SystemChangeNotifier uniqueInstance doSilently: [
			wrapper := SyMethodWrapper on: selector inClass: aClass for: self.
			wrapper install.
		].
		(self instrumentedMethodsAt: aClass) add: selector.
	].! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:23:09.66'!
instrumentedClasses

	^ classes ifNil: [classes := WeakSet new]! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:24:14.84'!
instrumentedMethods

	^ methods ifNil: [methods := WeakKeyDictionary new] ! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:24:05.214'!
instrumentedMethodsAt: aClass

	^ self instrumentedMethods at: aClass ifAbsentPut: [Set new]! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'SR 5/16/2010 16:25:39.999'!
isClassInstrumented: aClass

	^ self instrumentedClasses includes: aClass! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'SR 5/16/2010 16:25:48.289'!
isMethodInstrumented: selector inClass: aClass

	^ (self instrumentedMethods at: aClass ifAbsent: [Array empty]) includes: selector! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/17/2010 19:49:01.808'!
methodCalled: aSelector on: anObject with: anArrayOfObjects resulting: result

	self processor ifNotNil: [ self processor process: aSelector on: anObject with: anArrayOfObjects ].! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.324'!
processor
	^ processor! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.336'!
processor: anObject
	processor := anObject! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:36:25.493'!
uninstrumentAllAndReset

	self instrumentedClasses do: [:ea | 
		self uninstrumentClass: ea.
	].

	self instrumentedMethods keysAndValuesDo: [ :aClass :selectors | 
		selectors do: [:s | 
			self uninstrumentMethod: (aClass >> s).
		].
	].

	self instrumentedMethods keysAndValuesRemove: [:k :v | true ].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:37:17.823'!
uninstrumentClass: aClass

	| metaClass |
	metaClass := aClass class.
	(self isClassInstrumented: aClass) ifTrue: [
		self instrumentedClasses remove: aClass.
		self instrumentedClasses remove: metaClass ifAbsent: []
	].
	
	{aClass. metaClass} do: [:c |
		c methodDict values do: [:method | self uninstrumentMethod: method ]
	].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 17:20:18.101'!
uninstrumentMethod: aCompiledMethod

	| registeredMethods aClass selector |
	aClass := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.

	(self isMethodInstrumented: selector inClass: aClass)  ifTrue: [
		aCompiledMethod isMwMethodWrapper ifTrue: [	
			aCompiledMethod uninstall.
		].
	
		registeredMethods := self instrumentedMethodsAt: aClass.
		registeredMethods remove: selector.
		registeredMethods ifEmpty: [self instrumentedMethods removeKey: aClass].
	].! !

Object subclass: #SyOperation
	instanceVariableNames: 'selector receiverUUID arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyOperation class methodsFor: 'instance creation' stamp: 'SR 5/17/2010 20:14:46.955'!
receiver: aUUID selector: aSelector arguments: anArray

	^ self new
		receiverUUID: aUUID;
		selector: aSelector;
		arguments: anArray;
		yourself
		! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:33.632'!
arguments
	^ arguments! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:33.644'!
arguments: anObject
	arguments := anObject! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:40.664'!
receiverUUID
	^ receiverUUID! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:40.676'!
receiverUUID: anObject
	receiverUUID := anObject! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:48.177'!
selector
	^ selector! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:48.189'!
selector: anObject
	selector := anObject! !

Object subclass: #SyProtocolProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyProtocolProcessor methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2010 13:02:18.545'!
processDataFrom: aStream
	"Hint: Expect stream API from SocketStream. Other Streams should work as well."
	
	self subclassResponsibility.! !

!SyProtocolProcessor methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2010 13:02:30.633'!
sendOperationAsynchronously: anOperation to: aSocket
	"Handles sending the operation over the wire."
	
	self subclassResponsibility.! !

SyProtocolProcessor subclass: #SySimpleProtocolProcessor
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySimpleProtocolProcessor class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 13:03:35.969'!
on: aServer

	^ self new server: aServer.! !

!SySimpleProtocolProcessor methodsFor: 'as yet unclassified' stamp: 'SR 5/17/2010 20:32:10.577'!
processDataFrom: aStream
	"For now do nothing."
	
	| command |
	command := aStream upToAll: String crlf.
	(command = 'list') ifTrue: [ | objects data |
		"Execute list command: stream all objects to client."
		objects := self server metaObjects collect: [ :regObject | self pvtCreateObjectDictionary: regObject ].
		data := (Json render: objects), String crlf.

		aStream nextPutAllFlush: data; crlf.
		^ true
	].
	(command = 'quit') ifTrue: [
		^ false
	].
		! !

!SySimpleProtocolProcessor methodsFor: 'as yet unclassified' stamp: 'SR 5/17/2010 20:30:24.349'!
pvtCreateObjectDictionary: anRegisteredObject

	^ Dictionary new
		at: 'uuid' put: (anRegisteredObject uuid);
		at: 'type' put: (anRegisteredObject client className);
		at: 'data' put: (anRegisteredObject client instanceVariableValues);
		yourself.! !

!SySimpleProtocolProcessor methodsFor: 'as yet unclassified' stamp: 'SR 5/17/2010 21:22:15.174'!
sendOperationAsynchronously: anOperation to: aSocket
! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 5/15/2010 13:03:12.643'!
server

	^ server! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 5/15/2010 13:03:21.002'!
server: aServer

	server := aServer! !

Object subclass: #SyRegisteredObject
	instanceVariableNames: 'uuid client operations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:18.355'!
client
	^ client! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:18.366'!
client: anObject
	client := anObject! !

!SyRegisteredObject methodsFor: 'initialization' stamp: 'SR 5/17/2010 20:02:07.393'!
initialize

	super initialize.
	operations := OrderedCollection new.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:34.071'!
operations
	^ operations! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:34.083'!
operations: anObject
	operations := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:42.252'!
uuid
	^ uuid! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:42.265'!
uuid: anObject
	uuid := anObject! !

Object subclass: #SySimpleClient
	instanceVariableNames: 'socket instrumentor objects protocolProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Client'!

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/15/2010 14:52:28.811'!
connectToHostNamed: aHost port: aPort

	socket := SyTcpSocket openConnectionToHostNamed: aHost port: aPort.! !

!SySimpleClient methodsFor: 'connection-handling' stamp: 'mt 5/19/2010 12:57:46.766'!
disconnect

	socket ifNil: [^ self].
	
	socket close.
	
	objects := OrderedCollection new.
	instrumentor uninstrumentAllAndReset.! !

!SySimpleClient methodsFor: 'initialize-release' stamp: 'SR 5/17/2010 21:24:05.185'!
initialize

	super initialize.
	
	objects := OrderedCollection new.
	protocolProcessor := SySimpleProtocolProcessor on: self.
	instrumentor := SyClassInstrumentor new processor: self.! !

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/15/2010 14:50:21.163'!
isConnected

	socket ifNil: [ ^ false ].
	^ socket isConnected! !

!SySimpleClient methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 21:17:59.013'!
managedObjects

	^ objects collect: [ :regObject | regObject client ].! !

!SySimpleClient methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 21:23:00.934'!
process: aSelector on: anObject with: anArray

	| registeredObject operation |
	registeredObject := objects detect: [ :regObject | regObject client == anObject ] ifNone: [^ self].
	operation := SyOperation receiver: (registeredObject uuid) selector: aSelector arguments: anArray.
	
	registeredObject operations add: operation.
	protocolProcessor sendOperationAsynchronously: operation to: socket.! !

!SySimpleClient methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 21:18:48.002'!
pvtRegister: anObject with: aUUID

	| registeredObject |
	(self managedObjects contains: [ :o | o == anObject]) ifTrue: [ Exception signal: 'Object already registered' ].
	registeredObject := SyRegisteredObject new
		client: anObject;
		uuid: aUUID;
		yourself.
	objects add: registeredObject.
	
	"Wrap objects class if not yet wrapped"
	instrumentor instrumentClass: (anObject class).! !

!SySimpleClient methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 21:18:18.279'!
pvtUnregister: anObject

	objects removeAllSuchThat: [ :regObject | regObject client == anObject ].
	(objects contains: [ :o | o client class == anObject class]) ifFalse:	[
		instrumentor uninstrumentClass: (anObject class).
	].! !

!SySimpleClient methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 21:19:08.21'!
pvtUpdateManagedObjects

	| response rawResponse |
	"Send request"
	socket nextPutAllFlush: ('list', String crlf).
	rawResponse := socket upToAll: String crlf.
	response := Json readFrom: (ReadStream on: rawResponse).
	response keysAndValuesDo: [:key :data | | typeName variableData newObject |
		typeName := data at: 'type'.
		variableData := data at: 'data'.
		
		newObject := (Smalltalk at: (typeName asSymbol)) new.
		variableData withIndexDo: [:value :index | newObject instVarAt: index put: value].
		
		self pvtRegister: newObject with: key.
	].! !

Object subclass: #SyTcpServer
	instanceVariableNames: 'listenSocket listenProcess connections connectionProcesses connectionChangesMonitor protocolProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyTcpServer commentStamp: 'mt 5/19/2010 12:50:32.652' prior: 0!
I am able to accept and manage incoming TCP connections.!

SyTcpServer subclass: #SySimpleServer
	instanceVariableNames: 'objects instrumentor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SySimpleServer commentStamp: 'mt 5/19/2010 12:50:01.537' prior: 0!
Extends a TCP server with some managed objects.

Idea: Maybe we should composite this with a tcp server and not inherit from that...!

!SySimpleServer methodsFor: 'initialization' stamp: 'SR 5/17/2010 21:16:40.198'!
initialize

	super initialize.
	
	protocolProcessor := SySimpleProtocolProcessor on: self.
	objects := OrderedCollection new.
	instrumentor := SyClassInstrumentor new processor: self.! !

!SySimpleServer methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 20:17:07.054'!
managedObjects

	^ objects collect: [ :regObject | regObject client ].! !

!SySimpleServer methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 20:32:19.406'!
metaObjects

	^ objects! !

!SySimpleServer methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 21:22:36.344'!
process: aSelector on: anObject with: anArray

	| registeredObject operation |
	"Transcript show: aSelector; cr."
	registeredObject := objects detect: [ :regObject | regObject client == anObject ] ifNone: [^ self].
	operation := SyOperation receiver: (registeredObject uuid) selector: aSelector arguments: anArray.
	
	registeredObject operations add: operation.
	"protocolProcessor sendOperationAsynchronously: operation to: ???."! !

!SySimpleServer methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 20:15:18.01'!
register: anObject

	| registeredObject |
	(self managedObjects contains: [ :o | o == anObject]) ifTrue: [ Exception signal: 'Object already registered' ].
	registeredObject := SyRegisteredObject new
		client: anObject;
		uuid: (UUID new asString);
		yourself.
	objects add: registeredObject.
	
	"Wrap objects class if not yet wrapped"
	instrumentor instrumentClass: (anObject class).! !

!SySimpleServer methodsFor: 'managed-objects' stamp: 'SR 5/17/2010 20:06:39.209'!
unregister: anObject

	objects removeAllSuchThat: [ :regObject | regObject client == anObject ].
	(objects contains: [ :o | o client class == anObject class]) ifFalse:	[
		instrumentor uninstrumentClass: (anObject class).
	].! !

!SyTcpServer methodsFor: 'connection open/close' stamp: 'rkrk 5/14/2010 17:50'!
close

	"Closing listen part"
	listenProcess terminate.
	self listenSocket close.
	listenSocket := nil.
	
	"Closing connection part"
	self connectionProcesses do: [:proc | proc terminate].
	self connections do: [:ea | ea close].! !

!SyTcpServer methodsFor: 'waiting' stamp: 'SR 5/10/2010 18:25:52.291'!
connectionChangesMonitor

	^ connectionChangesMonitor! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'SR 5/10/2010 17:28:42.275'!
connectionProcesses

	^ connectionProcesses ifNil: [connectionProcesses := SySharedList new]! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:46:22.708'!
connections

	^ connections ifNil: [connections := SySharedList new]! !

!SyTcpServer methodsFor: 'synchronizing' stamp: 'SR 5/15/2010 13:53:12.092'!
connectionsChanged

	"[self connectionChangesMonitor signalAll]
		on: Error do: [:e |
			self
				log: 'Problem signaling connectionChangesMonitor';
				log: e.
			self halt.]."! !

!SyTcpServer methodsFor: 'initialization' stamp: 'SR 5/10/2010 18:26:19.094'!
initialize

	super initialize.
	
	connectionChangesMonitor := Monitor new.! !

!SyTcpServer methodsFor: 'testing' stamp: 'mt 5/9/2010 16:17:23.888'!
isListening

	^ self listenSocket isWaitingForConnection! !

!SyTcpServer methodsFor: 'connection open/close' stamp: 'rkrk 5/14/2010 13:30'!
listenOn: aPort

	self isListening ifTrue: [self error: 'Server already listening!!'].
	self listenSocket listenOn: aPort backlogSize: 4.
	self startListenThread.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 15:58:25.953'!
listenSocket

	^ listenSocket ifNil: [listenSocket := Socket newTCP]! !

!SyTcpServer methodsFor: 'debugging' stamp: 'rkrk 5/14/2010 17:31'!
log: msg

	Transcript cr; show: msg asString.! !

!SyTcpServer methodsFor: 'connection open/close' stamp: 'rkrk 5/14/2010 13:47'!
newConnectionOn: socket

	| con |
	con := SyTcpSocket on: socket.
	self connections add: con.
	self startConnectionThreadFor: con.
! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/9/2010 17:12:59.484'!
port

	^ self listenSocket port! !

!SyTcpServer methodsFor: 'threads' stamp: 'SR 5/17/2010 21:12:56.328'!
startConnectionThreadFor: aTcpSocket

	| connectionProcess |
	connectionProcess := [
		[aTcpSocket isConnected] whileTrue: [
			aTcpSocket waitForDataIfClosed: [
				self connections remove: aTcpSocket.
				self log: 'Some client socket closed'; log: aTcpSocket.
				self connectionsChanged
			].
			(protocolProcessor processDataFrom: aTcpSocket) ifFalse: [
				aTcpSocket close.
				self connections remove: aTcpSocket.
				self log: 'Some client socket closed'; log: aTcpSocket.
				self connectionsChanged
			]
		].
	].
	self connectionProcesses add: (connectionProcess forkAt: 35).! !

!SyTcpServer methodsFor: 'threads' stamp: 'SR 5/15/2010 12:36:03.582'!
startListenThread
	
	listenProcess := [
		[self isListening] whileTrue: [
				(self listenSocket waitForAcceptFor: 10) ifNotNilDo: [:socket |
					self newConnectionOn: socket.
					self log: 'New client connected'; log: socket.
					self connectionsChanged]]] forkAt: 35.! !

TestCase subclass: #SyCommunicationModuleTest
	instanceVariableNames: 'tcpServer tcpSocket openClientSockets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommunicationModuleTest class methodsFor: 'helper' stamp: 'rkrk 5/14/2010 17:02'!
closeAllSockets

	Socket registry keys
		select: [:ea | ea isWaitingForConnection or: [ea isOtherEndClosed] or: [ea isConnected]]
		thenDo: [:ea | ea close].! !

!SyCommunicationModuleTest class methodsFor: 'constants' stamp: 'rkrk 5/14/2010 14:24'!
defaultPort

	^ 22701! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/14/2010 18:19'!
connectTCPClientToServer

	tcpSocket := SyTcpSocket
		connectToHost: '127.0.0.1'
		port: self class defaultPort.
	openClientSockets add: tcpSocket.
	^ tcpSocket.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/14/2010 18:15'!
disconnectTCPClientsFromServer

	tcpSocket ifNotNil: [tcpSocket close. tcpSocket := nil].
	openClientSockets do: [:ea | ea close.]! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 5/15/2010 12:46:22.685'!
maybeWaitForServerThenDo: block

	"sometimes the server is already done before waiting is started so try the block
	first then optionally wait"
	tcpServer connectionChangesMonitor critical: [
		block on: Exception do: [
			Transcript cr;
				show: 'maybeWaitForServerThenDo: first try was failure in ';
					show: self selector.
			tcpServer connectionChangesMonitor wait.
			block value]].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:17'!
setUp

	super setUp.
	openClientSockets := OrderedCollection new.
	Transcript cr; show: 'start '; show: self selector.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 5/10/2010 11:39:41.976'!
startTcpServer

	tcpServer ifNil: [tcpServer := SyTcpServer new].
	tcpServer isListening
		ifFalse: [tcpServer listenOn: self class defaultPort].! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 5/10/2010 17:17:02.712'!
stopTcpServer

	(tcpServer notNil and: [tcpServer isListening])
		ifTrue: [tcpServer close].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:15'!
tearDown

	super tearDown.
	Transcript cr; show: 'end '; show: self selector.
	[self
		disconnectTCPClientsFromServer;
		stopTcpServer
	] on: Error do: [:e | Transcript cr; show: 'Error in tearDown'; print: e].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/14/2010 14:23'!
test01TcpServerStartup

	| sut |
	sut := SyTcpServer new.
	
	self deny: sut isListening.
	
	[sut listenOn: self class defaultPort.
	self
		assert: sut isListening;
		assert: self class defaultPort equals: sut port;
		assert: sut connections isEmpty.
	] ensure: [sut close].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/14/2010 14:24'!
test02TcpServerShutdown
	
	self
		startTcpServer;
		stopTcpServer;
		deny: tcpServer isListening;
		assert: tcpServer connections isEmpty;
		assert: (Socket registry keys noneSatisfy: [:socket | socket isWaitingForConnection]).! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'SR 5/15/2010 12:55:44.833'!
test03FailingTcpSocketConnection

	"try to connect to a server. This should either throw a ConnectionTimedOut error.
	Since we currently cannot control the timeout period of sockets and the default of 
	[Socket standardTimeout] = 45 is used we end the test earlier and just assume
	that the connection can't be established."
	<timeout: 6> "1s more than needed"
	| connectionFailed connectReturned connectProcess |
	connectionFailed := false.
	connectReturned := false.
	connectProcess := [
		[self connectTCPClientToServer. connectReturned := true]
			on: ConnectionTimedOut
			do: [connectionFailed := true]] fork.
	self wait: 5. "seconds"
	connectProcess terminate.
	connectionFailed ifTrue: [^self].
	connectReturned ifTrue: [^self]. "assume it works"
	self
		assert: false
		description: '#connectTCPClientToServer was successful although no server was started!!'.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'SR 5/15/2010 12:44:53.636'!
test04TcpSocketConnection

	<timeout: 5>
	self
		startTcpServer;
		connectTCPClientToServer;
		assert: tcpSocket isConnected;
		maybeWaitForServerThenDo: [self assert: 1 equals: tcpServer connectionProcesses size].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'SR 5/15/2010 12:55:36.418'!
test05TcpServerIncomingConnections

	self
		startTcpServer;
		assert: tcpServer connections isEmpty;
		connectTCPClientToServer;
		maybeWaitForServerThenDo: [self assert: tcpServer connections size = 1].

	self connectTCPClientToServer.
		
	self
		maybeWaitForServerThenDo: [self assert: tcpServer connections size = 2];
		disconnectTCPClientsFromServer;
		assert: tcpServer connections size = 1.
	
	self assert: tcpServer connections isEmpty.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/14/2010 16:55'!
wait: seconds

	(Delay forSeconds: seconds) wait.! !

TestCase subclass: #SySimpleClientGetObjectTest
	instanceVariableNames: 'server o1 o2 sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleClientGetObjectTest class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 14:41:32.817'!
defaultPort

	^ 22701! !

!SySimpleClientGetObjectTest methodsFor: 'running' stamp: 'SR 5/15/2010 14:30:22.383'!
setUp

	server := SySimpleServer new.
	o1 := Person givenName: 'Micha' surname: 'Test'.
	o2 := Person givenName: 'Christoph' surname: 'Muster'.
	server
		register: o1;
		register: o2;
		listenOn: self class defaultPort.
		
	sut := SySimpleClient new.! !

!SySimpleClientGetObjectTest methodsFor: 'running' stamp: 'SR 5/17/2010 20:43:22.489'!
tearDown

	server
		unregister: o1;
		unregister: o2;
		close.! !

!SySimpleClientGetObjectTest methodsFor: 'testing' stamp: 'SR 5/15/2010 14:52:42.972'!
test01ConnectDisconnect

	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: sut isConnected.
	sut disconnect.! !

!SySimpleClientGetObjectTest methodsFor: 'testing' stamp: 'SR 5/15/2010 14:52:48.597'!
test02GetObjects

	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: sut isConnected.
	
	self assert: (sut managedObjects size = 2).
	self assert: (sut managedObjects contains: [:o| o = o1]).
	self assert: (sut managedObjects contains: [:o| o = o2]).
	
	
	sut disconnect.! !

TestCase subclass: #SySimpleServerObjectRepoTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleServerObjectRepoTests methodsFor: 'running' stamp: 'SR 5/15/2010 12:08:17.176'!
setUp

	super setUp.
	sut := SySimpleServer new.! !

!SySimpleServerObjectRepoTests methodsFor: 'testing' stamp: 'SR 5/15/2010 12:20:41.821'!
test01UnRegisterObject

	| o1 |
	o1 := Person new.
	self assert: (sut managedObjects isEmpty).
	sut register: o1.
	self assert: (sut managedObjects size = 1).
	sut unregister: o1.
	self assert: (sut managedObjects isEmpty).! !

!SySimpleServerObjectRepoTests methodsFor: 'testing' stamp: 'SR 5/16/2010 17:13:07'!
test02DoubleRegistration

	| o1 alreadyRegisteredException |
	o1 := Person new.
	self assert: (sut managedObjects isEmpty).
	sut register: o1.
	self assert: (sut managedObjects size = 1).
	
	alreadyRegisteredException := false.
	[sut register: o1]
		on: Exception
		do: [ alreadyRegisteredException := true ].
	self assert: alreadyRegisteredException.
	
	sut unregister: o1.
! !

!SySimpleServerObjectRepoTests methodsFor: 'testing' stamp: 'SR 5/16/2010 17:13:28.379'!
test03UnWrapObject

	| o1 |
	o1 := Person new.
	self deny: (o1 class methodDict values first isMwMethodWrapper).
	sut register: o1.
	self assert: (o1 class methodDict values first isMwMethodWrapper).
	sut unregister: o1.
	self deny: (o1 class methodDict values first isMwMethodWrapper).! !

!SySimpleServerObjectRepoTests methodsFor: 'testing' stamp: 'SR 5/17/2010 21:06:49.522'!
test04OperationStackTest

	| o1 |
	o1 := Person new.
	sut register: o1.

	self assert: ((sut metaObjects detect: [:o | o client == o1 ]) operations isEmpty).
	o1 givenName: 'Test2'.
	self assert: ((sut metaObjects detect: [:o | o client == o1 ]) operations size = 1).
	self assert: ((sut metaObjects detect: [:o | o client == o1 ]) operations first selector = #givenName:).

	sut unregister: o1.
! !

OrderedCollection subclass: #SySharedList
	instanceVariableNames: 'mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySharedList commentStamp: 'mt 5/9/2010 17:04:27.753' prior: 0!
This is meant to be a thread-safe version of an OrderedCollection. See the "list" protocol to explore selectors which are thread-safe.!

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:52:24.122'!
add: anElement

	^ self mutex critical: [super add: anElement].! !

!SySharedList methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:40:52.25'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:53:19.735'!
remove: anElement ifAbsent: aBlock
	"#remove: should also be guarded now."
	
	^ self mutex critical: [super remove: anElement ifAbsent: aBlock].! !
